//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit6.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit5.h"
#include "LPE.cpp"
#include "CImage.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
int moy;
double Histo[256];
typedef struct LPE{
int x;
int y;
int z;    //intensit du pixel
double buffer_double;
int buffer_int;
int region;
} algo;

algo image[256][256];
int classe[256][256];
algo *minima ;
algo *minima1 ;
int nb_region;
//***********
BYTE R,G,B;
char *titre;
CImage *imagel,*image_contour,*origine,*resultat,*buffer1,*buffer2;
CImage **experience;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//------------------------- Ouvrir une image -----------------------------------


void __fastcall TForm1::ChargerImage1Click(TObject *Sender)
{

OpenPictureDialog1->Execute();

Form1->Image2->Picture->LoadFromFile(OpenPictureDialog1->FileName) ;
Form1->Image1->Visible=false;
Form1->PageControl2->Visible=true;
Form1->Label8->Visible=true;
int i,j;
//remplir la matrice image

for(i=0;i<256;i++)
{
 for(j=0;j<256;j++)
 {
 matrix[i][j].moy=( GetRValue(Form1->Image2->Canvas->Pixels[i][j])+GetGValue(Form1->Image2->Canvas->Pixels[i][j])+GetBValue(Form1->Image2->Canvas->Pixels[i][j]) )/3;
 matrix[i][j].x=i;
 matrix[i][j].y=j;
 }
  }
}
//----------------------------- Enregistrer Image ------------------------------

void __fastcall TForm1::Enregistrer1Click(TObject *Sender)
{
if(SavePictureDialog1->Execute())
{
Form1->Image2->Picture->SaveToFile(ChangeFileExt(SavePictureDialog1->FileName, ".BMP"));

 }
}
//------------------------------ Fermer la fentre principale ------------------
void __fastcall TForm1::Quitter1Click(TObject *Sender)
{
 Form1->Close();
}
//----------------------------- A propos ---------------------------------------
void __fastcall TForm1::Apropos3Click(TObject *Sender)
{
Form6->Show();
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------



//------------------------------------------------------------------------------


//--------------------Ouvrir IRM -----------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
  OpenPictureDialog1->Execute();

Form1->Image2->Picture->LoadFromFile(OpenPictureDialog1->FileName) ;
Form1->Image1->Visible=false;
Form1->PageControl2->Visible=true;
Form1->Label8->Visible=true;
Form1->Image8->Picture=Form1->Image2->Picture ;
Form1->Image5->Picture=Form1->Image2->Picture ;
Form1->Image3->Picture=Form1->Image2->Picture ;
int i,j;

//remplir la matrice image

for(i=0;i<=256;i++)
{
 for(j=0;j<=256;j++)
 {
 matrix[i][j].moy=( GetRValue(Form1->Image2->Canvas->Pixels[i][j])+GetGValue(Form1->Image2->Canvas->Pixels[i][j])+GetBValue(Form1->Image2->Canvas->Pixels[i][j]) )/3;
 matrix[i][j].x=i;
 matrix[i][j].y=j;
 }
  }
}
//----------------------------- Histogramme ------------------------------------

void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
  Form2->Show();
  Form1->Label1->Visible=true;
  Form1->Image3->Visible=true;
     TRect TheRect;

TheRect=Rect(Form2->Image1->Left+5,Form2->Image1->Top+5,290,410);
 Form2->Image1->Canvas->Brush->Color = clWhite;

Form2->Image1->Canvas->FrameRect(TheRect);
Form2->Image1->Canvas->Pen->Color=clBlack;
Form2->Image1->Canvas->MoveTo(Form2->Image1->Left+15,50);
Form2->Image1->Canvas->LineTo(Form2->Image1->Left+15,380);
//Canvas->MoveTo(Form2->Image1->Left+15,380);
//Canvas->LineTo(Form2->Image1->Width-10,380);
    int i,j,Nivgris;
    for(i=0;i<256;i++)
    {
    Form2->HISTOG[i]=0;
    }

      for(i=0;i<=Form1->Image2->Picture->Height-1;i++)
      {
      for(j=0;j<=Form1->Image2->Picture->Width-1;j++)
      {
      Nivgris=Form1->matrix[i][j].moy;
       Form2->HISTOG[Nivgris]++;
      }
      }


         for(int i=0;i<256;i++)
    {
       Form2->Image1->Canvas->Pen->Color=RGB(i,i,i);
    Form2->Image1->Canvas->MoveTo(i+Form2->Image1->Left+15,380);
    Form2->Image1->Canvas->LineTo(i+Form2->Image1->Left+15,400);
    Form1->Image3->Picture=Form1->Image2->Picture ;
     }



    for(int i=1;i<256;i++)
    {
     if(Form2->HISTOG[i]<=3800){
      Form2->Image1->Canvas->Pen->Color=clBlack;
    Form2->Image1->Canvas->MoveTo(i+Form2->Image1->Left+15,380);
    Form2->Image1->Canvas->LineTo(i+Form2->Image1->Left+15,380-(Form2->HISTOG[i]/10)); }
    else {
     Form2->Image1->Canvas->Pen->Color=clBlack;
       Form2->Image1->Canvas->MoveTo(i+Form2->Image1->Left+15,380);
    Form2->Image1->Canvas->LineTo(i+Form2->Image1->Left+15,15);
    }
    }

}
//-----------------------Fermer l'application-----------------------------------

void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
 Form1->Close();
}
//------------------------Bouton Save-------------------------------------------

void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
if(SavePictureDialog1->Execute())
{
Image2->Picture->SaveToFile(ChangeFileExt(SavePictureDialog1->FileName, ".BMP"));

 }

}
//-------------------- Erosion Binaire -----------------------------------------

void __fastcall TForm1::Erosion1Click(TObject *Sender)
{
  int i,j,a;
float s;
s=StrToFloat(Form1->Edit3->Text);
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        a=erosion(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
    }
    }


     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }



}
//----------------------Erosion au Niveaux de Gris -----------------------------


void __fastcall TForm1::Erosion2Click(TObject *Sender)
{
int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=erosion(i,j);
    }
    }


     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
       }
       }


}
//---------------------------------------------------------------------------

//--------------- Bouton Transformation morpho ------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
 int i,j;

switch  ( ComboBox1->ItemIndex )
{
 case 0 : // Erosion binaire
           int i,j,a;
           float s;
           s=StrToFloat(Form1->Edit3->Text);
           for(i=1;i<256;i++)
           {
            for(j=1;j<256;j++)
            {
             a=erosion(i,j);
             if (a>s){mat[i][j]=255;}
             else  mat[i][j]=0;
             }
            }

     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
       }
       }

         break ;


 case 1: // Dilatation Binaire

           for(i=1;i<256;i++)
           {
            for(j=1;j<256;j++)
            {
             a=dilatation(i,j);
             if (a>s){mat[i][j]=255;}
             else  mat[i][j]=0;
             }
            }

     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
       }
       }

        break ;
 case 2: //Ouverture Binaire

         for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        a=erosion(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
        a=dilatation(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
       }
       }
         break ;
 case 3: // Fermeture binaire
         for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        a=dilatation(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
        a=erosion(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4  et image 9
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
         break ;
}
switch  ( ComboBox2->ItemIndex )
{
case 0 : // Erosion au Niveau de gris
        int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=erosion(i,j);
    }
    }


     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }

         break ;
case 1: //Dilatation NG

  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j);
    }
    }


     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
         break ;
case 2: // Ouverture NG

         for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=erosion(i,j);
        mat[i][j]=dilatation(i,j);
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
          break ;
case 3: // Fermeture NG
       for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j);
        mat[i][j]=erosion(i,j);
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
       break ;
 }

switch  ( ComboBox3->ItemIndex )
{
case 0 : // Gradient
        for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j)-erosion(i,j);
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
        break;
case 1 : // Gradient interne
          for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=mat[i][j]-erosion(i,j);
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
           break;
case 2 : // Gradient externe
           for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j)-mat[i][j];
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
           break;
case 3 : // Laplacien  Morpho
           for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=(dilatation(i,j)+erosion(i,j))-(2*mat[i][j]);
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
           break;
case 4 : // Filtre Altrn Squentiel
        int ferm, ouver;
        for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j);   // FAS = ouveture(fermeture(f))
        mat[i][j]=erosion(i,j);
        ferm=mat[i][j];
        mat[i][j]=erosion(i,j);
        mat[i][j]=dilatation(i,j);
        ouver=mat[i][j];
        mat[i][j]=ferm;
        mat[i][j]=ouver;
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;


       }
       }
        break;

case 5 : // Chapeau haut de forme  BLANC

        for(i=1;i<256;i++)
    { int ouvert;
    for(j=1;j<256;j++)
    {
        // WTH(f)=f-ouverture(f)
        mat[i][j]=erosion(i,j);
        mat[i][j]=dilatation(i,j);
        ouvert=mat[i][j];
        mat[i][j]= mat[i][j]-ouvert;

    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
        break;

case 6 : // Chapeau haut de forme NOIR
        for(i=1;i<256;i++)
    {  int ferme ;
    for(j=1;j<256;j++)
    {
        // BTH(f)=fermeture(f)-f
        mat[i][j]=dilatation(i,j);
        mat[i][j]=erosion(i,j);
        ferme=mat[i][j];
        mat[i][j]= ferme-mat[i][j];

    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
        break;

}
}
//-----------------------------Sauvegarde de l'image traite -------------------

void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
if(SavePictureDialog1->Execute())
{
Image4->Picture->SaveToFile(ChangeFileExt(SavePictureDialog1->FileName, ".BMP"));

 }

}
//----------------------------------- dilatation binaire -----------------------

void __fastcall TForm1::Dilatation1Click(TObject *Sender)
{
 int i,j,a;
float s;
s=StrToFloat(Form1->Edit3->Text);
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        a=dilatation(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
    }
    }


     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
        
       }
       }


}
//-------------------------- Ouverture Binaire ---------------------------------

void __fastcall TForm1::Ouverture1Click(TObject *Sender)
{  int i,j,a;
float s;
s=StrToFloat(Form1->Edit3->Text);
 for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        a=erosion(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
        a=dilatation(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
       }
       }
}
//-------------------------- Fermeture Binaire ---------------------------------

void __fastcall TForm1::Fermeture1Click(TObject *Sender)
{ int i,j,a;
float s;
s=StrToFloat(Form1->Edit3->Text);
for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        a=dilatation(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
        a=erosion(i,j);
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
       }
       }
}
//----------------------- Dilatation au NG -------------------------------------

void __fastcall TForm1::Dilatation2Click(TObject *Sender)
{
  int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j);
    }
    }


     Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
}
//--------------------- Ouverture au NG ----------------------------------------

void __fastcall TForm1::Ouverture2Click(TObject *Sender)
{
  for(int i=1;i<256;i++)
    {
    for(int j=1;j<256;j++)
    {
        mat[i][j]=erosion(i,j);
        mat[i][j]=dilatation(i,j);
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(int i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(int j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
              }
       }
}
//-------------------------- Fermeture au NG ----------------------------------

void __fastcall TForm1::Fermeture2Click(TObject *Sender)
{
  for(int i=1;i<256;i++)
    {
    for(int j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j);
        mat[i][j]=erosion(i,j);
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(int i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(int j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
}
//-------------------------------- Gradient Morpho -----------------------------

void __fastcall TForm1::gradientClick(TObject *Sender)
{ int i,j;

  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j)-erosion(i,j);

    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
              }
       }
}
//------------------------- Filtre moyenneur -----------------------------------

void __fastcall TForm1::Moyenneur1Click(TObject *Sender)
{
 int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=Moyenneur(i,j);

    }
    }


    Form1->Image6->Height=Form1->Image2->Height;
     Form1->Image6->Width=Form1->Image2->Width ;
//affichage dans image6
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image6->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);

       }
       }
}
//----------------------Proprit fentre-------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
 Form1->PageControl2->Visible=false;
 Form1->Label8->Visible=false;
 Form1->Image5->Picture=Form1->Image2->Picture ;
 Form1->Image8->Picture=Form1->Image2->Picture ;
 
 

}
//-------------------------- Filtre smooth -------------------------------------


void __fastcall TForm1::Smooth1Click(TObject *Sender)
{
  int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=Smooth(i,j);

    }
    }
    Form1->Image6->Height=Form1->Image2->Height;
     Form1->Image6->Width=Form1->Image2->Width ;
//affichage dans image6
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image6->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);

       }
       }
}
//----------------------- Filtre Median ----------------------------------------

void __fastcall TForm1::Median1Click(TObject *Sender)
{
  int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=median(i,j);

    }
    }
    Form1->Image6->Height=Form1->Image2->Height;
     Form1->Image6->Width=Form1->Image2->Width ;
//affichage dans image6
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image6->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);

       }
       }
}
//------------------------Filtre Maximum ---------------------------------------

void __fastcall TForm1::Maximum1Click(TObject *Sender)
{
  int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=maximum(i,j);

    }
    }
     Form1->Image6->Height=Form1->Image2->Height;
     Form1->Image6->Width=Form1->Image2->Width ;
//affichage dans image6
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image6->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);

       }
       }
}
//------------------------- Filtre Minimum -------------------------------------

void __fastcall TForm1::Minimum1Click(TObject *Sender)
{
 int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=minimum(i,j);

    }
    }
     Form1->Image6->Height=Form1->Image2->Height;
     Form1->Image6->Width=Form1->Image2->Width ;
//affichage dans image6
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image6->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);

       }
       }
}
//------------------------ Filtre Sobel ----------------------------------------

void __fastcall TForm1::Sobel1Click(TObject *Sender)
{
 int i,j;
     for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=voisinsobel(i,j);

    }
    }
    Form1->Image7->Height=Form1->Image2->Height;
     Form1->Image7->Width=Form1->Image2->Width ;
//affichage dans image7
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image7->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);


       }
       }
}
//----------------------------- Laplacien -------------------------------------

void __fastcall TForm1::Laplacien1Click(TObject *Sender)
{
  int i,j;
 for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=voisinlaplace(i,j);

    }
    }
    Form1->Image7->Height=Form1->Image2->Height;
     Form1->Image7->Width=Form1->Image2->Width ;
//affichage dans image7
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image7->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);

       }
       }
}
//--------------------------- Prewitt -------------------------------------

void __fastcall TForm1::Prewitt1Click(TObject *Sender)
{
 int i,j;
 for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
    mat[i][j]=voisinprewitt(i,j);

    }
    }
    Form1->Image7->Height=Form1->Image2->Height;
     Form1->Image7->Width=Form1->Image2->Width ;
//affichage dans image7
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image7->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
              }
       }
}
//------------------------------------------------------------------------------//
//******************************------------************************************//
//-----------------------------** Algo k-means **-------------------------------//
//*******************************----------************************************//

void __fastcall TForm1::SpeedButton7Click(TObject *Sender)
{

//lecture nb minima(centre d'une rgion) et iteration max

int nb_region,nb_iter_max;
int h=1,larg,haut;
nb_region = Edit1->Text.ToIntDef(3);
//ComboBox4->Clear();
//for (int i=0;i<nb_region;i++) {ComboBox4->Items->Add(IntToStr(i));}

nb_iter_max = Edit2->Text.ToIntDef(10);

larg=256;
haut=256;

//
//initialisation de toute la matrice

for (int i=0;i<larg;i++)
{
 for (int j=0;j<haut;j++)
	{
int moy;  // rcupration des coordonnes et NG des pixels
moy = (GetRValue(Image8->Canvas->Pixels[i][j])+GetGValue(Image8->Canvas->Pixels[i][j])+GetBValue(Image8->Canvas->Pixels[i][j]) )/3;
image[i][j].x = i;
image[i][j].y = j;
image[i][j].z = moy;
	}}
//initialisation des rgions

minima = new algo [nb_region+1];
minima1= new algo [nb_region+1];

for (int i=0;i<nb_region;i++)
{

minima[i].x =random(256);
minima[i].y =random(256);
minima1[i].x = minima[i].x;
minima1[i].y = minima[i].y;
int x,y;
x=minima[i].x ;
y=minima[i].y ;
minima[i].z = moy = image[x][y].z ;

}

bool end = false;
h=1;
//boucle sur nb_iter_max
while ((h< nb_iter_max)&&(end == false))
{

	//pour chaque point de l'image
	for (int i=0;i<larg;i++)
	{
	 for (int j=0;j<haut;j++)
	{

	//calcul de la distance
	for (int s=0;s<nb_region;s++)
	{

	//dist euclidienne
       minima[s].buffer_double = sqrt( pow((image[i][j].z - minima[s].z),2) );




	}   //fin bcle



/*----------- Tobogganing --------------------------------------------------------------------------------------------------/
/ Another approach is to slide down a watershed to the common minimum.This approach links each pixel with the             /
/ smallest of its neighbors.That one is linked to the smallest of its neighbors,that one to the smallest of its neighbors,  /
/ etc.Eventually you get to points that have no smaller neighbors(localminima),which form the basis for a watershed         /
/ region.The closure of all points that eventually link to the same minimum defines the watershed.This approach has         /
/ been dubbed tobogganing because of its similarity to riding a sled down amountainside                                   /
/--------------------------------------------------------------------------------------------------------------------------*/

//affecter un point au minima (centre) le plus proche
		//recherche minimum
		double min;
		int ind;
		min = minima[0].buffer_double;
		ind = 0;

		for (int s=0;s<nb_region;s++)
		{
		if (minima[s].buffer_double < min )
					{
		min = minima[s].buffer_double ;
		ind = s ;
					}
		}

			//affecter au minimum
		image[i][j].region = ind;
                classe[i][j]=ind;

	}} //fin bcle point image

int minima_y,nby;
int minima_x,nbx;
bool cond=true;
//calcul des nouveaux minima
for (int s=0;s<nb_region;s++)
{

	minima_y =0;
	nby=1;
	minima_x =0;
	nbx=1;
	//x

	for (int i=0;i<larg;i++)
	{
	 for (int j=0;j<haut;j++)
		{
		if (image[i][j].region == s )
					{
		minima_x += image[i][j].x ;
		nbx++;
					 }
		}}

minima[s].x = div(minima_x,nbx).quot;
if (minima1[s].x != minima[s].x) cond=false;




	//y

	for (int i=0;i<larg;i++)
	{
	 for (int j=0;j<haut;j++)
		{
		if (image[i][j].region == s )
					{
		minima_y += image[i][j].y;
		nby++;
					 }
		}}

minima[s].y = div(minima_y,nby).quot;
if (minima1[s].y != minima[s].y) cond=false;

//z
minima[s].z = image[minima[s].x ][minima[s].y].z;

}
if (cond) end=true;
else {
for (int i=0;i<nb_region;i++)
{
minima1[i].x=minima[i].x;
minima1[i].y=minima[i].y;
}
  }
h++;

}//fin bcle iter

//colorier les pixels de l'image suivant les differentes classe ;
//obtenir couleur alatoire

int couleur;

for (int i=0;i<larg;i++)
{
 for (int j=0;j<haut;j++)
{

couleur = image[i][j].region * (div(1600000,nb_region).quot);
Image10->Canvas->Pixels[i][j] = RGB ( couleur,couleur ,couleur );

}
}



 }
//------------------  --------------------------------------



//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
{
  Form3->Show();

}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton9Click(TObject *Sender)
{
int numreg = 1;
for (int i=0;i<256;i++)
{
 for (int j=0;j<256;j++)
{
if (image[i][j].region == numreg )

Image10->Canvas->Pixels[i][j] = Shape4->Brush->Color;

}}        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Shape4MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (ColorDialog1->Execute())
    Shape4->Brush->Color = ColorDialog1->Color;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ColorDialog1Close(TObject *Sender)
{
Shape4->Brush->Color = ColorDialog1->Color;
}
//-------------------------- Gradient M ----------------------------------------

void __fastcall TForm1::GradientM1Click(TObject *Sender)
{
for(int i=1;i<256;i++)
    {
    for(int j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j)-erosion(i,j);
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(int i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(int j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
              }
       }        
}
//--------------------------- FAS ----------------------------------------------

void __fastcall TForm1::FAS1Click(TObject *Sender)
{
 int i,j,ferm, ouver;
        for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j);   // FAS = ouveture(fermeture(f))
        mat[i][j]=erosion(i,j);
        ferm=mat[i][j];
        mat[i][j]=erosion(i,j);
        mat[i][j]=dilatation(i,j);
        ouver=mat[i][j];
        mat[i][j]=ferm;
        mat[i][j]=ouver;
    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4  
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;


       }
       }
}
//------------------------- Gradient Interne -----------------------------------

void __fastcall TForm1::GradientInterne1Click(TObject *Sender)
{ int i,j;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=mat[i][j]-erosion(i,j);
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
}
//--------------------- Gradient Externe ---------------------------------------

void __fastcall TForm1::GradientExterne1Click(TObject *Sender)
{ int i,j;
 for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=dilatation(i,j)-mat[i][j];
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;
              }
       }
}
//------------------------Laplacient M ----------------------------------------


void __fastcall TForm1::LaplacienM1Click(TObject *Sender)
{ int i,j;           // L(I)= grad ext-grad inter =(dilat + erod)- 2I
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {
        mat[i][j]=(dilatation(i,j)+erosion(i,j))-(2*mat[i][j]);
    }
    }
Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
}
//------------------------- White Top Hat -------------------------------------

void __fastcall TForm1::ChapeauHautdeFormeBlanc1Click(TObject *Sender)
{
     int i,j,ouver,d;
        for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {    mat[i][j]=erosion(i,j);
        mat[i][j]=dilatation(i,j);
        ouver=mat[i][j];
        // WTH(f)=f-ouverture(f)
        d= mat[i][j]-ouver;
        mat[i][j]=d;

    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
}
//-------------------------- Black Top Hat -------------------------------------

void __fastcall TForm1::ChapeauHautdeFormeNoir1Click(TObject *Sender)
{  int i,j,ferm,d;
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {    mat[i][j]=dilatation(i,j);
        mat[i][j]=erosion(i,j);
        ferm=mat[i][j];
        // BTH(f)=fermeture(f)-f
        d= ferm-mat[i][j];
        mat[i][j]=d;

    }
    }
    Form1->Image4->Height=Form1->Image2->Height;
     Form1->Image4->Width=Form1->Image2->Width ;
//affichage dans image4 
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image4->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image5->Picture=Form1->Image2->Picture ;

       }
       }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton10Click(TObject *Sender)
{
if(this->OpenPictureDialog2->Execute())
Image11->Picture->LoadFromFile(this->OpenPictureDialog2->FileName);
titre=(this->OpenPictureDialog2->FileName.c_str());
}
//-----------------------------------------------------------------------//
//------------------------ LPE S.BEUCHER --------------------------------//
//-----------------------------------------------------------------------//


void __fastcall TForm1::SpeedButton12Click(TObject *Sender)
{
bool Noyau[9];
for(int i=0;i<9;i++) Noyau[i]=1;
imagel = new CImage(titre);
image_contour = new CImage(titre);
origine = new CImage(titre);
resultat = new CImage(titre);
buffer1 = new CImage(titre);
buffer2 = new CImage(titre);

experience = new CImage*[12];
for (int i=0;i<12;i++){
experience[i] = new CImage(titre);
   }

//traitement

experience[0]->LoadBmp(titre);
experience[0]->ContrasteAuto(GRAY,experience[1]);
experience[1]->Threashold(experience[1]->thrFuzzy(),experience[2] );
experience[2]->NOT(experience[3]);
experience[3]->morCloseHole(3,experience[4]);
experience[4]->NOT(experience[3]);
experience[3]->LaplaceII(GRAY,experience[4]);
experience[4]->Threashold(10,experience[4]);
experience[4]->DistanceMorphologique(3,true,experience[5]);
experience[5]->ContrasteAuto(GRAY,experience[5]);
experience[5]->Inversion(experience[6]);
experience[6]->ErosionNG(Noyau,9,0,experience[7]);
experience[7]->FindMinimum(experience[8]);
experience[6]->LPE(9,10,4);
experience[9]->lpeFrontiere(experience[4],experience[10]);
experience[10]->Superposition(experience[1]);

//affichage

//experience[0]->DrawImage(this->Image11->Canvas->Handle,346,346,1);
//experience[1]->DrawImage(this->Image12->Canvas->Handle,346,346,1);
experience[2]->DrawImage(this->Image13->Canvas->Handle,346,346,1);
//experience[3]->DrawImage(this->Image14->Canvas->Handle,346,346,1);
experience[4]->DrawImage(this->Image15->Canvas->Handle,346,346,1);
experience[5]->DrawImage(this->Image16->Canvas->Handle,346,346,1);
//experience[6]->DrawImage(this->Image17->Canvas->Handle,346,346,1);
//experience[7]->DrawImage(this->Image18->Canvas->Handle,346,346,1);
experience[8]->DrawImage(this->Image19->Canvas->Handle,346,346,1);
experience[9]->DrawImage(this->Image20->Canvas->Handle,346,346,1);
experience[10]->DrawImage(this->Image21->Canvas->Handle,346,346,1);

for(int i=0; i<512;i++)
for(int j=0; j<512;j++)
{
int R=GetRValue(Image21->Picture->Bitmap->Canvas->Pixels[i][j]);
if(R==220)Image20->Picture->Bitmap->Canvas->Pixels[i][j]=RGB(255,10,10);

}        
}
//----------------------- Seuillage --------------------------------------

void __fastcall TForm1::SpeedButton13Click(TObject *Sender)
{
int i,j,a;
float s;
s=StrToFloat(Form1->Edit4->Text);
  for(i=1;i<256;i++)
    {
    for(j=1;j<256;j++)
    {  a=Image2->Canvas->Pixels[i][j] ;
    if (a>s){mat[i][j]=255;}
     else  mat[i][j]=0;
    }
    }


     Form1->Image12->Height=Form1->Image2->Height;
     Form1->Image12->Width=Form1->Image2->Width ;
//affichage dans image12
    for(i=0;i<Form1->Image2->Picture->Width-1;i++)
     {
      for(j=0;j<Form1->Image2->Picture->Height-1;j++)
      {
       Form1->Image12->Canvas->Pixels[i][j]=RGB(mat[i][j],mat[i][j],mat[i][j]);
       Form1->Image3->Visible=true;
       Form1->Label1->Visible=true;
       }
       }

}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton15Click(TObject *Sender)
{
if(SavePictureDialog1->Execute())
{
Image7->Picture->SaveToFile(ChangeFileExt(SavePictureDialog1->FileName, ".BMP"));

 }
}
//---------------------------------------------------------------------------


